﻿@page "/"
@page "/customers"

@using Easy4Us.Web.Pages.Campaign
@using Easy4Us.Web.Pages.Customer

@using Easy4Us.Application.Interfaces
@using Easy4Us.Application.DTO

@using Easy4Us.Infra.CrossCutting.Common.Interfaces


@inject IUserAccessor  UserAccessor
@inject ICampaignAppService CampaignAppService
@inject ICustomerAppService CustomerAppService

<div class="card shadow-lg">
    <div class="card-header font-weight-bold">
        <div class="container-fluid">
            <div class="row">
                <div class="col">
                    <span>Campaign: </span>
                    <BSButtonGroup>
                        <BSDropdown>
                            <BSDropdownToggle>@(selectedCampaing?.Name ?? "None")</BSDropdownToggle>
                            @if(campaigns != null)
                            {
                                <BSDropdownMenu>
                                    @foreach (var campaign in campaigns)
                                    {
                                        <BSDropdownItem OnClick="@(() => LoadPage(campaign))">@campaign.Name</BSDropdownItem>
                                    }
                                </BSDropdownMenu>
                            }
                        </BSDropdown>
                    </BSButtonGroup>
                </div>
            </div>
        </div>
    </div>
    <div class="card-body">
        <div class="container-fluid">
            <div class="row">
                <div class="col-8">
                    <p>@(selectedCampaing?.Description ?? "No description avaiable.")</p>
                </div>
                <div class="col-4">
                    <ul>
                        @if (customers != null && customers.Count() > 0)
                        {
                            <li>Customers: @customers.Count()</li>
                            <li>
                                Cleared: @customers.Where(x => x.USP == Domain.Enums.ValidationStatus.VALID &&
                                  x.GAMA == Domain.Enums.ValidationStatus.VALID &&
                                  x.SFDC == Domain.Enums.ValidationStatus.VALID &&
                                  x.NewEasy == Domain.Enums.ValidationStatus.VALID).Count()
                            </li>
                            <li>Updated: @customers.LastOrDefault().LastUpdated.ToString("dd MMM, yyyy HH:mm tt")</li>
                        }
                        else
                        {
                            <li>Customers: 0</li>
                            <li>Cleared: 0</li>
                            <li>Updated: Never</li>
                        }
                    </ul>
                </div>
                <div class="w-100"></div>
                <div class="col-8">
                    @if (selectedCampaing != null)
                    {
                        <span>
                            @selectedCampaing.StartDate.ToString("dd MMM, yyyy")
                            to
                            @selectedCampaing.EndDate.ToString("dd MMM, yyyy")
                        </span>
                    }
                </div>
                <div class="col-4">
                    <button class="btn btn-primary float-right" @onclick="RefreshCustomers">Refresh</button>
                </div>
            </div>
            <div class="row">
            </div>
        </div>
    </div>
</div>

<br />

<ListCustomers Customers="customers"></ListCustomers>

@code {

    private CampaignDTO selectedCampaing;
    private IEnumerable<CampaignDTO> campaigns;
    private IEnumerable<CustomerDTO> customers;

    protected override async Task OnInitializedAsync()
    {
        await LoadPage();
    }

    private async Task LoadPage()
    {
        campaigns = await CampaignAppService.GetCampaigns();

        CampaignDTO campaign = null;

        if (campaigns != null && campaigns.Count() > 0)
        {
            campaign = campaigns.FirstOrDefault();
        }

        await LoadPage(campaign);
    }

    private async Task LoadPage(CampaignDTO campaignDTO)
    {
        selectedCampaing = campaignDTO;
        customers = await CustomerAppService.GetCustomers(selectedCampaing?.Name ?? "", UserAccessor.GetCurrentUserDisplayName());
    }

    private async Task RefreshCustomers()
    {
        customers = await CustomerAppService.Refresh(selectedCampaing?.Name ?? "", UserAccessor.GetCurrentUserDisplayName());
    }
}